package ro.pub.cs.pp.a51hadoop.algorithm;
/*
 * A reduction function R that maps hash values back into secret values.
 *
 * There are many possible implementations for this function, and it's only
 * important that it behaves pseudorandomly.
 *
 * By alternating the hash function with the reduction function,
 * chains of alternating passwords and hash values are formed.
 */
public interface HashReducer
{
	/*
	 * Apply the current Reducer on the given hash.
	 *
	 * @return a new secret value
	 */
	public String apply(String txt);
}

